// Jarbles.java
// Copyright (C) 2006-2013 by Jeff Gold.
//
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see
// <http://www.gnu.org/licenses/>.
//
// ---------------------------------------------------------------------
//
// An applet for containing a GraphicPlayer.  At some point this should
// evolve to support theme selection, artificial opponents, network play
// and so on.
package net.esclat.jarbles;
import net.esclat.ripple.Standalone;
import net.esclat.jarbles.abalone.Board;
import net.esclat.jarbles.abalone.GraphicPlayer;
import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Dimension;

public class Jarbles extends Applet implements Runnable {
    static final long serialVersionUID = 0;
    GraphicPlayer gp = new GraphicPlayer();
    long time = 0;
    public void init() {
        setLayout(new GridLayout());
        gp.setContext(getAppletContext());
        add(gp);
        try { time = 1000 * Long.parseLong(getParameter("time"));
        } catch (NumberFormatException nfe) {}
    }
    public void start() {
        new Thread(this).start();
        gp.startElapseThread();
    }

    public void run() { Board.game(time, gp, gp); }
    public void update(Graphics g) { paint(g); }
    public Dimension getPreferredSize() {
        return gp.getPreferredSize();
    }
    public Dimension getMinimumSize() {	return gp.getMinimumSize(); }

    public static void main(String args[]) {
        Standalone.app(new Jarbles(), null, "images/jarbles.png", args);
    }
}
